require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/tools/images', type: :request do
  # Tools::Image. As you add validations to Tools::Image, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) { {rca_id: rca.id, tool_reference: 1, name: 'Image 1', file: image_ok} }

  let(:invalid_attributes) { {rca_id: rca.id, tool_reference: 1, name: 'Image 1', file: nil} }

  let(:image_ok) do
    ActiveStorage::Blob.create_and_upload!(
      io: File.open(file_ok, 'rb'),
      filename: 'image_ok.png',
      content_type: 'image/png'
    ).signed_id
  end

  let(:file_ok) { Rails.root.join('spec', 'support', 'assets', 'images', 'image_ok.png') }

  let(:rca) { FactoryBot.create(:rca, methodology: methodology) }
  let(:methodology) { FactoryBot.create(:methodology, :with_step_1) }
  let(:user) { FactoryBot.create(:user) }

  context 'From logged user' do
    before :each do
      user.set_session(:active_step_tool, methodology.steps.first.step_tools.first.id)
      user.save!

      sign_in user
    end

    describe 'GET /index' do
      context 'without rca defined' do
        it 'renders a redirection response' do
          get tools_images_url

          expect(response).to have_http_status(:redirect)
          expect(response).to redirect_to(rcas_path)
        end
      end

      context 'with rca and step_tool defined' do
        it 'renders a successful response' do
          Tools::Image.create! valid_attributes

          get('/tools/images', params: {rca: rca.id})
          expect(response).to be_successful
        end
      end
    end

    # describe 'GET /show' do
    #   it 'renders a successful response' do
    #     tools_image = Tools::Image.create! valid_attributes
    #     get tools_image_url(tools_image)
    #     expect(response).to be_successful
    #   end
    # end

    describe 'GET /new' do
      it 'renders a successful response' do
        get new_tools_image_url(tools_image: valid_attributes)
        expect(response).to be_successful
      end
    end

    describe 'GET /edit' do
      it 'render a successful response' do
        tools_image = Tools::Image.create! valid_attributes
        get edit_tools_image_url(tools_image)
        expect(response).to be_successful
      end
    end

    describe 'POST /create' do
      context 'with valid parameters' do
        it 'creates a new Tools::Image' do
          expect {
            post tools_images_url, params: { tools_image: valid_attributes }
          }.to change(Tools::Image, :count).by(1)
        end

        it 'redirects to the tools_image index' do
          post tools_images_url, params: { tools_image: valid_attributes }
          expect(response).to redirect_to(tools_images_url(rca: rca))
        end
      end

      context 'with invalid parameters' do
        it 'does not create a new Tools::Image' do
          expect {
            post tools_images_url, params: { tools_image: invalid_attributes }
          }.to change(Tools::Image, :count).by(0)
        end

        it 'renders a successful response (i.e. to display the new template)' do
          post tools_images_url, params: { tools_image: invalid_attributes }
          expect(response).to be_successful
        end
      end
    end

    describe 'PATCH /update' do
      context 'with valid parameters' do
        let(:new_attributes) { {name: 'Nouveau nom'} }

        it 'updates the requested tools_image' do
          tools_image = Tools::Image.create! valid_attributes
          patch tools_image_url(tools_image), params: { tools_image: new_attributes }
          tools_image.reload

          expect(tools_image.name).to eq 'Nouveau nom'
        end

        it 'redirects to the tools_image index' do
          tools_image = Tools::Image.create! valid_attributes
          patch tools_image_url(tools_image), params: { tools_image: new_attributes }
          tools_image.reload
          expect(response).to redirect_to(tools_images_url(rca: rca))
        end
      end

      context 'with invalid parameters' do
        it 'renders a successful response (i.e. to display the edit template)' do
          tools_image = Tools::Image.create! valid_attributes
          patch tools_image_url(tools_image), params: { tools_image: invalid_attributes }
          expect(response).to be_successful
        end
      end
    end

    describe 'DELETE /destroy' do
      it 'destroys the requested tools_image' do
        tools_image = Tools::Image.create! valid_attributes
        expect {
          delete tools_image_url(tools_image)
        }.to change(Tools::Image, :count).by(-1)
      end

      it 'redirects to the tools_images list' do
        tools_image = Tools::Image.create! valid_attributes
        delete tools_image_url(tools_image)
        expect(response).to redirect_to(tools_images_url(rca: rca))
      end
    end
  end
end
